<?php
// A class to help work with Sessions
// In our case, primarily to manage logging users in and out

// Keep in mind when working with sessions that it is generally 
// inadvisable to store DB-related objects in sessions

class Session {
	
	private $logged_in=false;
	public $user_id;
	
	function __construct() {
		session_start();
		$this->check_login();
    if($this->logged_in) {
      // actions to take right away if user is logged in
    } else {
      // actions to take right away if user is not logged in
    }
	}
	
  public function is_logged_in() {
    return $this->logged_in;
  }

	public function login($user) {
    // database should find user based on username/password
    if($user){
        //defined('DS') ? null : define('DS', DIRECTORY_SEPARATOR);
        $this->user_id = $_SESSION['user_id'] = $user->id;
        $this->logged_in = true;
        $pathdir = $_SERVER['DOCUMENT_ROOT'].DS.'Login'.DS.'Buyer'.DS;
        if(!is_dir($pathdir.DS.$user->username)) {
            mkdir($pathdir.DS.$user->username);
        }
    }
  }
  
  public function logout() {
    unset($_SESSION['user_id']);
    unset($this->user_id);
    $this->logged_in = false;
  }

	private function check_login() {
    if(isset($_SESSION['user_id'])) {
      $this->user_id = $_SESSION['user_id'];
      $this->logged_in = true;
    } else {
      unset($this->user_id);
      $this->logged_in = false;
    }
  }
  
}

$session = new Session();

?>